﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Microsoft.Win32;

namespace Installer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
//------------------Бухгалтерия-------------------------------------//
        private void button1_Click(object sender, EventArgs e)
        {
            if (buh == "")
            {
                MessageBox.Show("Не найдена отчетность!");
                return;
            }
            int i=0;
            while(i<listBox1.SelectedItems.Count)
            {
                CopyDir(buh,keys[listBox1.Items.IndexOf(listBox1.SelectedItems[i])]+"ExtForms");
                i++;            
            }
            MessageBox.Show("Копирование завершено!");
        }
//------------------------------------------------------------------//
//------------------УСН---------------------------------------------//       
        private void button2_Click(object sender, EventArgs e)
        {
            if (usn == "")
            { MessageBox.Show("Не найдена отчетность!");
              return; 
            }
            int i=0;
            while(i<listBox1.SelectedItems.Count)
            {
                CopyDir(usn,keys[listBox1.Items.IndexOf(listBox1.SelectedItems[i])]+"ExtForms");
                i++;            
            }
            MessageBox.Show("Копирование завершено!");
        }       
//------------------------------------------------------------------//        
//------------------Свободное копирование---------------------------// 
        
        private void button3_Click(object sender, EventArgs e)
        {
            int i=0;
            while(i<listBox1.SelectedItems.Count)
            {
                CopyDir(fldr.Text,keys[listBox1.Items.IndexOf(listBox1.SelectedItems[i])]+"ExtForms"+fldr.Text.Substring(fldr.Text.LastIndexOf(@"\")));
                i++;            
            }
            MessageBox.Show("Копирование завершено!");
        }
//------------------------------------------------------------------// 
        RegistryKey readKey;
        string[] keys;
        string buh = "";
        string usn = "";
        private void Form1_Load(object sender, EventArgs e)
        {
            readKey = Registry.CurrentUser.OpenSubKey("software\\1C\\1Cv7\\7.7\\Titles");
            string loadString = (string)readKey.GetValue("ВПК");
            keys = readKey.GetValueNames();
            int i=0;
            while (i<keys.Length)
            {
                listBox1.Items.Add((string)readKey.GetValue(keys[i]));
                i++;
            }
         string[] ots=Directory.GetDirectories(Application.StartupPath);         
            
            foreach( string so in ots)
                {
                    if (so.Contains("General.")) { buh = so; CheckDir(buh); }
                    if (so.Contains("USN.")) { usn = so; CheckDir(usn);}               
                }
            fldr.Text = Application.StartupPath;
         }

        void CopyDir(string FromDir, string ToDir)
        {
            if (!Directory.Exists(ToDir))
                Directory.CreateDirectory(ToDir);

            foreach (string s1 in Directory.GetFiles(FromDir))
            {
                string s2 = ToDir + "\\" + Path.GetFileName(s1);
                File.Copy(s1, s2,true);
            }
            foreach (string s in Directory.GetDirectories(FromDir))
            {
                CopyDir(s, ToDir + "\\" + Path.GetFileName(s));
            }
        }
       
        void CheckDir(string Dir)
        {
            Directory.SetCurrentDirectory(Dir);
            string[] ff=Directory.GetFiles(Dir,"*.EXE");
            for(int i=0;i<ff.Length;i++)
            {
                    System.Diagnostics.Process MyProc = new System.Diagnostics.Process();
                    MyProc.StartInfo.FileName = ff[i]; ;
                    MyProc.Start();
                    MyProc.WaitForExit();
                    MyProc.Dispose();
                    if(i!=(ff.Length-1))
                    File.Delete(Dir + "\\RPLIST.TXT");
                    File.Delete(ff[i]);
            }
            foreach (string s in Directory.GetDirectories(Dir))
            {
                CheckDir(s);
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                readKey.Close();
            }
            catch { }
        }

        private void folders_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.SelectedPath = fldr.Text;
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
                fldr.Text = folderBrowserDialog1.SelectedPath;
            
        }
    }
   
}
